#include "crossroads.h"

void show_status (int ac, char **av) {
    int i, j;

    for (i = 0; i < nservice; i++) {
	if (i)
	    putchar ('\n');
	alloc_reporter (service + i, 0);
	msg ("Reporting service %s (pid = %d)",
	     service[i].name, servicereport->pid);
	printf ("Service:            %s\n"
		"  Active sessions : %d\n",
		service[i].name, servicereport->nclients);
	for (j = 0; j < service[i].nbackend; j++) {
            printf ("  Backend %2d      : %s is %s\n"
                    "    Hits          : %lu failures in %lu sessions\n"
                    "    Usage         : %llu secs, %llu bytes\n",
		    j,
		    service[i].backend[j].name,
		    state_to_string (servicereport->backendstate[j].avail),
		    servicereport->backendstate[j].failures,
		    servicereport->backendstate[j].totuses,
		    servicereport->backendstate[j].nsec,
		    servicereport->backendstate[j].nbytes);
	    if (service[i].dispatchover)
		printf ("    Average       : %lu secs, %lu bytes\n",
			servicereport->backendstate[j].avg_nsec,
			servicereport->backendstate[j].avg_nbytes);
	}
	
	if (shmdt (servicereport) < 0)
	    error ("Failure releasing reporter memory: %s",
		   strerror(errno));
    }
}
