#include "crossroads.h"

int backend_available () {
    int i;
    
    /* Just see if all back ends are flagged down. In that case
     * we return 0.
     * We won't actually connect here with a back end, tcp_serve()
     * will do that later on.
     */

    for (i = 0; i < activeservice->nbackend; i++)
	if (servicereport->backendstate[i].avail == st_available) {
	    msg ("Found (at least) one available back end\n");
	    return (1);
	}

    msg ("Found no available back end!\n");
    return (0);
}
